<?php

function calculer_champ_LOGO($fonctions, $nom_champ, $id_boucle, &$boucles, $id_mere)
{
# Les logos (rubriques, articles...)

# 'LOGO_ARTICLE':
# 'LOGO_ARTICLE_NORMAL':
# 'LOGO_ARTICLE_RUBRIQUE':
# 'LOGO_ARTICLE_SURVOL':
# 'LOGO_AUTEUR':
# 'LOGO_AUTEUR_NORMAL':
# 'LOGO_AUTEUR_SURVOL':
# 'LOGO_SITE':
# 'LOGO_BREVE':
# 'LOGO_BREVE_RUBRIQUE':
# 'LOGO_MOT':
# 'LOGO_RUBRIQUE':
# 'LOGO_RUBRIQUE_NORMAL':
# 'LOGO_RUBRIQUE_SURVOL':
# 'LOGO_DOCUMENT':

		ereg("^LOGO_(([a-zA-Z]+).*)$", $nom_champ, $regs);
		$type_logo = $regs[1];
		$type_objet = strtolower($regs[2]);
		$filtres = '';
		if ($fonctions) {
			while (list(, $nom) = each($fonctions)) {
				if (ereg('^(left|right|center|top|bottom)$', $nom))
					$align = $nom;
				else if ($nom == 'lien') {
					$flag_lien_auto = 'oui';
					$flag_stop = true;
				}
				else if ($nom == 'fichier') {
					$flag_fichier = 'oui';
					$flag_stop = true;
				}
				else if ($nom == '')	// double || signifie "on passe aux filtres"
					$flag_stop = true;
				else if (!$flag_stop) {
					$lien = $nom;
					$flag_stop = true;
				}
				else // apres un URL ou || ou |fichier ce sont des filtres (sauf left...lien...fichier)
					$filtres[] = $nom;
			}
			// recuperer les filtres s'il y en a
			$fonctions = $filtres;
		}
		if ($flag_lien_auto && !$lien) {
			$milieu .= "
			\$lien = generer_url_$type_objet(" .
		index_pile($id_boucle,  'id_$type_objet', &$boucles) . ");
			";
		}
		else
		  {
		    $milieu .= "\n\t\$lien = ";
		    $a = $lien;
		    while (ereg("^([^#]*)#([A-Za-z_]+)(.*)$", $a, $match))
		      {
			list($c,$m) = calculer_champ("", $match[2], $id_boucle, &$boucles, $id_mere);
			// $m est nul dans les cas prvus
			$milieu .= ((!$match[1]) ? "" :"'$match[1]' .") . " $c .";
			$a = $match[3];
		      }
		    if ($a) $milieu .= "'$lien';"; 
		    else 
		      {
			if ($lien) $milieu = substr($milieu,1,-1) .";";
			else $milieu .= "'';";
		      }
		  }

		if ($type_logo == 'RUBRIQUE') {
			$milieu .= '
			list($logon, $logoff) = IMG_image(image_rubrique(' .
		index_pile($id_boucle,  "id_rubrique", &$boucles) . '));
			';
		}
		else if ($type_logo == 'RUBRIQUE_NORMAL') {
			$milieu .= '
			list($logon,) = IMG_image(image_rubrique(' .
		index_pile($id_boucle,  "id_rubrique", &$boucles) . '));
			$logoff = "";
			';
		}
		else if ($type_logo == 'RUBRIQUE_SURVOL') {
			$milieu .= '
			list(,$logon) = IMG_image(image_rubrique(' .
		index_pile($id_boucle,  "id_rubrique", &$boucles) . '));
			$logoff = "";
			';
		}
		else if ($type_logo == 'DOCUMENT'){
			$milieu .= '
			$logon = integre_image(' .
		index_pile($id_boucle,  "id_document", &$boucles) . ',"","fichier_vignette");
			$logoff = "";
			';
		}
		else if ($type_logo == 'AUTEUR') {
			$milieu .= '
			list($logon, $logoff) = IMG_image(image_auteur(' .
		index_pile($id_boucle,  "id_auteur", &$boucles) . '));
			';
		}
		else if ($type_logo == 'AUTEUR_NORMAL') {
			$milieu .= '
			list($logon,) = IMG_image(image_auteur(' .
		index_pile($id_boucle,  "id_auteur", &$boucles) . '));
			$logoff = "";
			';
		}
		else if ($type_logo == 'AUTEUR_SURVOL') {
			$milieu .= '
			list(,$logon) = IMG_image(image_auteur(' .
		index_pile($id_boucle,  "id_auteur", &$boucles) . '));
			$logoff = "";
			';
		}
		else if ($type_logo == 'BREVE') {
			$milieu .= '
			list($logon, $logoff) = IMG_image(image_breve(' .
		index_pile($id_boucle,  "id_breve", &$boucles) . '));
			';
		}
		else if ($type_logo == 'BREVE_RUBRIQUE') {
		  $milieu .= '
			list($logon, $logoff) = IMG_image(image_breve(' .
		index_pile($id_boucle,  "id_breve", &$boucles) . '));
			if (!$logon)
				list($logon, $logoff) = IMG_image(image_rubrique(' .
		index_pile($id_boucle,  "id_rubrique", &$boucles) . '));
		  ';
		}
		else if ($type_logo == 'SITE') {
			$milieu .= '
			list($logon, $logoff) = IMG_image(image_site(' .
		index_pile($id_boucle,  "id_syndic", &$boucles) . '));
			';
		}
		else if ($type_logo == 'MOT') {
			$milieu .= '
			list($logon, $logoff) = IMG_image(image_mot(' .
		index_pile($id_boucle,  "id_mot", &$boucles) . '));
			';
		}
		else if ($type_logo == 'ARTICLE') {
			$milieu .= '
			list($logon, $logoff) = IMG_image(image_article(' .
		index_pile($id_boucle,  "id_article", &$boucles) . '));
			';
		}
		else if ($type_logo == 'ARTICLE_NORMAL') {
			$milieu .= '
			list($logon,) = IMG_image(image_article(' .
		index_pile($id_boucle,  "id_article", &$boucles) . '));
			$logoff = "";
			';
		}
		else if ($type_logo == 'ARTICLE_SURVOL') {
			$milieu .= '
			list(,$logon) = IMG_image(image_article(' .
		index_pile($id_boucle,  "id_article", &$boucles) . '));
			$logoff = "";
			';
		}
		else if ($type_logo == 'ARTICLE_RUBRIQUE') {
			$milieu .= '
			list($logon, $logoff) = IMG_image(image_article(' .
		index_pile($id_boucle,  "id_article", &$boucles) . '));
			if (!$logon)
				list($logon, $logoff) = IMG_image(image_rubrique(' .
		index_pile($id_boucle,  "id_rubrique", &$boucles) . '));
			';
		}
		if ($flag_fichier)
			$code = "ereg_replace('^/?IMG/','',\$logon)"; // compatibilite ascendante : pas de 'IMG/'
		else
			$code = "affiche_logos(\$logon, \$logoff, \$lien, '".
				addslashes($align) . "')";

		list($c,$m) = applique_filtres($fonctions, $code, $id_boucle, $boucles, $id_mere);
		return array($c,$milieu . $m);
}

?>
